commit 7f82734a2bd3cb45de9711bc31a48a2ae3b7113d
Author: freddy77 <freddy77>
Date:   Thu Jan 10 16:05:59 2008 +0000

    add a test for SQLCancel which seems broken

diff --git a/ChangeLog b/ChangeLog
index 238d403..30115b3 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Thu Jan 10 17:04:15 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/.cvsignore src/odbc/unittests/Makefile.am:
+	* src/odbc/unittests/cancel.c(added):
+	- add test for SQLCancel
+
 Thu Jan 10 16:28:44 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/blob1.c src/odbc/unittests/cursor3.c:
 	* src/odbc/unittests/cursor4.c src/odbc/unittests/cursor5.c:
@@ -20,4 +25,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2460 2008/01/10 15:29:03 freddy77 Exp $
+$Id: ChangeLog,v 1.2461 2008/01/10 16:05:59 freddy77 Exp $
diff --git a/src/odbc/unittests/.cvsignore b/src/odbc/unittests/.cvsignore
index d7c663e..ae23946 100644
--- a/src/odbc/unittests/.cvsignore
+++ b/src/odbc/unittests/.cvsignore
@@ -64,3 +64,4 @@ cursor5
 attributes
 hidden
 blob1
+cancel
diff --git a/src/odbc/unittests/Makefile.am b/src/odbc/unittests/Makefile.am
index 830c6c5..7fca97b 100644
--- a/src/odbc/unittests/Makefile.am
+++ b/src/odbc/unittests/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.70 2008/01/10 13:21:12 freddy77 Exp $
+# $Id: Makefile.am,v 1.71 2008/01/10 16:05:59 freddy77 Exp $
 TESTS		=	\
 			t0001$(EXEEXT) t0002$(EXEEXT) t0003$(EXEEXT)\
 			t0004$(EXEEXT) connect$(EXEEXT) print$(EXEEXT)\
@@ -20,7 +20,8 @@ TESTS		=	\
 			paramcore$(EXEEXT) timeout2$(EXEEXT) timeout3$(EXEEXT) \
 			connect2$(EXEEXT) timeout4$(EXEEXT) freeclose$(EXEEXT) \
 			cursor3$(EXEEXT) cursor4$(EXEEXT) cursor5$(EXEEXT) \
-			attributes$(EXEEXT) hidden$(EXEEXT) blob1$(EXEEXT)
+			attributes$(EXEEXT) hidden$(EXEEXT) blob1$(EXEEXT) \
+			cancel$(EXEEXT)
 
 check_PROGRAMS	=	$(TESTS)
 
@@ -79,6 +80,7 @@ cursor5_SOURCES	= cursor5.c common.c common.h
 attributes_SOURCES	= attributes.c common.c common.h
 hidden_SOURCES	= hidden.c common.c common.h
 blob1_SOURCES	= blob1.c common.c common.h
+cancel_SOURCES = cancel.c common.c common.h
 
 AM_CPPFLAGS	=	-I$(top_srcdir)/include $(ODBC_INC) -DFREETDS_SRCDIR=\"$(srcdir)\"
 if MINGW32
diff --git a/src/odbc/unittests/cancel.c b/src/odbc/unittests/cancel.c
new file mode 100644
index 0000000..b01630f
--- /dev/null
+++ b/src/odbc/unittests/cancel.c
@@ -0,0 +1,96 @@
+/* Testing SQLCancel() */
+
+#include "common.h"
+#include <signal.h>
+
+#ifdef HAVE_ALARM
+
+#define CHECK_RCODE(t,h,m) \
+   if ( rcode != SQL_NO_DATA \
+     && rcode != SQL_SUCCESS \
+     && rcode != SQL_SUCCESS_WITH_INFO  \
+     && rcode != SQL_NEED_DATA ) { \
+      fprintf(stderr,"Error %d at: %s\n",rcode,m); \
+      getErrorInfo(t,h); \
+      exit(1); \
+   }
+
+static SQLCHAR sqlstate[SQL_SQLSTATE_SIZE + 1];
+
+static void
+getErrorInfo(SQLSMALLINT sqlhdltype, SQLHANDLE sqlhandle)
+{
+	SQLRETURN rcode = 0;
+	SQLINTEGER naterror = 0;
+	SQLCHAR msgtext[SQL_MAX_MESSAGE_LENGTH + 1];
+	SQLSMALLINT msgtextl = 0;
+
+	rcode = SQLGetDiagRec((SQLSMALLINT) sqlhdltype,
+			      (SQLHANDLE) sqlhandle,
+			      (SQLSMALLINT) 1,
+			      (SQLCHAR *) sqlstate,
+			      (SQLINTEGER *) & naterror,
+			      (SQLCHAR *) msgtext, (SQLSMALLINT) sizeof(msgtext), (SQLSMALLINT *) & msgtextl);
+	fprintf(stderr, "Diagnostic info:\n");
+	fprintf(stderr, "  SQL State: %s\n", (char *) sqlstate);
+	fprintf(stderr, "  SQL code : %d\n", (int) naterror);
+	fprintf(stderr, "  Message  : %s\n", (char *) msgtext);
+}
+
+static void
+exit_forced(int s)
+{
+	exit(1);
+}
+
+static void
+sigalrm_handler(int s)
+{
+	SQLRETURN rcode;
+
+	printf(">>>> SQLCancel() ...\n");
+	rcode = SQLCancel(Statement);
+	printf(">>>> ... SQLCancel done rcode = %d\n", rcode);
+	CHECK_RCODE(SQL_HANDLE_STMT, Statement, "SQLCancel failed");
+
+	alarm(4);
+	signal(SIGALRM, exit_forced);
+}
+
+int
+main(int argc, char **argv)
+{
+	SQLRETURN rcode;
+
+	use_odbc_version3 = 1;
+	Connect();
+
+	printf(">> Select tab1...\n");
+	alarm(4);
+	signal(SIGALRM, sigalrm_handler);
+	rcode = SQLExecDirect(Statement, (SQLCHAR *) "WAITFOR DELAY '000:05:00'", SQL_NTS);
+	if (rcode != SQL_ERROR) {
+		fprintf(stderr, "SQLExecDirect should return error\n");
+		return 1;
+	}
+	getErrorInfo(SQL_HANDLE_STMT, Statement);
+	if (strcmp(sqlstate, "HY008") != 0) {
+		fprintf(stderr, "Unexpected sql state returned\n");
+		return 1;
+	}
+	printf(">> ...  done rcode = %d\n", rcode);
+	signal(SIGINT, NULL);
+
+	Disconnect();
+	return 0;
+}
+
+#else
+int
+main(void)
+{
+	printf("Not possible for this platform.\n");
+	return 0;
+}
+#endif
+

